Revision History:
----------------

Version 2.50 release notes -- 5/05/2009
  http://www.cerberusftp.com/
  - Updated the OpenSSL packages to the latest versions
  - Fixed a bug with the SIZE command

Version 2.49b release notes -- 2/13/2009
  http://www.cerberusftp.com/
  
  - Added an option to disable shutting down the server when the operating system is shutting down
  - Updated the log4cxx and OpenSSL packages to the latest versions
  - Fixed an incompatibility with some FTP clients when using secure connections
  - Fixed a bug that sometimes resulted in the server service shutting down when a
    user logged out
  - Updated the log4cxx and OpenSSL packages to the latest versions
  - Cerberus now binds to the C-Runtime libraries dynamically


Version 2.48 release notes -- 6/26/2008
  http://www.cerberusftp.com/
  
  - The RETR command now correctly returns an error code when a path is a directory
    instead of a file.  This will improve Firefox compatibility.
  - Updated the log4cxx and OpenSSL packages to the latest versions


Version 2.47 release notes -- 2/10/2008
  http://www.cerberusftp.com/
  
  - Fixed a bug that resulted in no response being sent back for an unsupported MODE
  - Added an option to disable/enable detection of IPv6 addresses
  - Fixed a toolbar display issue
  - The columns in the main tab window now auto-resize when the applications size changes


Version 2.46 release notes -- 11/7/2007
  http://www.cerberusftp.com/
  
  - Fixed a bug that prevented blocking a connected user from the GUI
  - Fixed a bug that caused the MDTM command to fail when setting a date/time
    and the file path contains spaces
  - Fixed a bug that resulted in a failure code being returned when a directory LIST or NLST
    filter returned no matching files
  - Fixed an XSS vulnerability in the web interface


Version 2.45 release notes -- 4/27/2007
  http://www.cerberusftp.com/
  
  - Fixed a bug that prevented blocking a connected user from the GUI
  - Fixed a dynamic DNS bug that resulted in the wrong external IP being used
    when multiple interfaces are resolving from different DNS addresses
  - Fixed a bug in the IP blocker dialog that sometimes failed to properly delete
    an IP address


Version 2.44 release notes -- 3/27/2007
  http://www.cerberusftp.com/
  
  - Fixed a display bug in the generate statistics function 
  - Fixed a dynamic DNS bug
  - Fixed a bug in the IP block list that prevented IP addresses from being deleted
  - Fixed a bug in the IP block manager that resulted in corrupt block list upgrades
    from verison 2.42 and below
  - Fixed a bug in that sometimes resulted in failed active data connections
  - Upgraded the IP block list file format to XML


Version 2.43 Official release notes -- 3/19/2007
  http://www.cerberusftp.com/
  
  - Preliminary IPv6 Support
  - Resolved installation issues on Windows 2000
  - Added an option to always use the local address for passive commands when the connection 
    is on the same LAN


Version 2.42 Official release notes -- 2/27/2007
  http://www.cerberusftp.com/
  
  - Resolved a bug that could result in a crash when generating a statistics file
  - Resolved a bug resulting in a connection never terminating when a remote client's
    connection is broken during an upload to the server
  - Compiled against the most recent version of OpenSSL (0.9.8e)
 

Version 2.41 Official release notes -- 2/21/2007
  http://www.cerberusftp.com/
  
  - Updated the logging system to use the latest version of log4cxx
  - Fixed a bug that resulted in the log file failing to be updated when running as a service
  - Updated the gSOAP support and fixed a realm authentication bug
  - Added support for the EPRT and EPSV commands
  - Compiled against the most recent version of OpenSSL (0.9.8d)


Version 2.4 Official release notes -- 9/09/2006
  http://www.cerberusftp.com/
  
  - Fixed a GDI resource leak
  - Fixed an bug that caused an error message to be displayed when a user initiated a file backup
  - Compiled against the most recent version of OpenSSL (0.9.8c)


Version 2.4 BETA 3 release notes -- 5/18/2006
  http://www.cerberusftp.com/
  
  - Added a confirmation dialog for deleting user and virtual directories
  - Added a users file backup and backup restore capability
  - Compiled against the latest OpenSSL release (0.9.8b)
  

Version 2.4 BETA 2 release notes -- 5/07/2006
  http://www.cerberusftp.com/
  
  - Changed the FEAT command response to more closely match the FTP RFC
  - Added SSLv3/TLSv1 support
  - Added option to require SSL/TLS control and data protection
  - Added option to require NT users to be part of a security group before
    authorizing access
  - Miscellaneous minor bug fixes and UI improvements


Version 2.4 BETA 1 release notes -- 11/20/2005
  http://www.cerberusftp.com/
  
  - Fixed a DDoS bug
  - Added explicit SSLv2 support
  - Fixed an incompatibility with Firefox that resulted in directory contents sometimes
    not being shown in Firefox
  - Improved web services support
  - New file logging system based on log4cxx (work in progress)


Version 2.32 release notes -- 7/07/2005
  http://www.cerberusftp.com/
  
  - Fixed an IP manager GUI bug
  - Added data validation to several IP manager fields
  - Fixed a bug that sometimes caused the server to crash when closing


Version 2.31 release notes -- 6/15/2005
  http://www.cerberusftp.com/
  
  - Fixed Getting Started Wizard bug
  - Improved the login notification messages
  - Fixed several dialog inconsistencies
  - Added descriptions to several menu items


Version 2.3 release notes -- 6/12/2005
  http://www.cerberusftp.com/

  - Fixed a bug that resulted in virtual directories mapped directly to drives
    sometimes not displaying without checking the "Show Hidden Folders" property
  - Added the SITE CHMOD command to allow for limited file property changes
  - Fixed a minor GUI resource leak
  - Improved the progress bar look
  - Progress bars no longer require 1% of the transfer to complete before appearing
  - Added tooltip help to many of the dialog controls
  - Added several new root directory options for NT authenticated users
  - Added color coding for different types of log messages
  - Added a desktop popup notification window for new connections
  - Corrected a minor bug that resulted in "log" being appended to whatever directory
    was selected as the log file directory for XML logging
  - Dialogs now tab correctly
  - New look to the Server, IP, and User manager
  - New Hi-color icons for the toolbar and dialog boxes
  - Improved WAN auto-detection with shorter timeout
  - Users can now launch the initial setup screen from the main menu
  - Numerous minor bug fixes and UI improvements

Version 2.23 BETA release notes -- 2/05/2005
  http://www.cerberusftp.com/

  - Replacing an existing file using rename now requires delete permission
  - Added number of connections and current transfer rates as tooltip bubbles on the 
    notification icon
  - Corrected a bug that allowed users to continue to attempt to login after they had been
    autoblocked if the connection remained open
  - Replaced a few icons with enhanced Hi-color icons
  - Added current transfer rate indicators to the status bar
  - Corrected a bug that sometimes showed the date in the wrong format during a "LIST" operation
  - Corrected a few bugs that could result in incorrect transfer rates being displayed during a
    file transfer. Updated the transfer rates to reflect current transfer rate as opposed to
    average transfer rate.
  - User and group information should now be displayed for directory items listed
    during a wildcard "LIST"
  - Added configurable denied welcome message for when the server is set to not accept logins
  - The taskbar notification icon now changes when the server has at least one user connected
  - Cerberus can now detect and add itself to the Windows Firewall exclusion list
  - MDTM time can now be configured to set the modification time and access time on a file


------------------------------------------------


Version 2.22 Official release notes -- 9/23/2004
  http://www.cerberusftp.com/

  - Fixed a timeout bug in the "Optimized file transfer" mode.
  - Cancelling a connection now properly terminates users who are transfering files
  - The correct tooltips are now displayed for the Connections and Transfers tabs
  - The Transfers tab now displays the bytes transfered out of total
  - The Speed value on the Transfers tab now has 2 decimal places of precision.
  - Added right-click menu option to terminate a connection from the Transfers tab
  - Fixed a bug that resulted in connection IDs being displayed in the wrong base format
  - Fixed a bug in the IP Manager that could result in corrupt IP blocking file when only
    a single address was entered to block

------------------------------------------------


Version 2.21 Official release notes -- 9/02/2004
  http://www.cerberusftp.com/

  - Fixed a bug in the "Use Optimized Transfer mode" setting that resulted in corrupted files
    being transfered
  - Installer now changes default send and receive buffer size to 64KB.


------------------------------------------------


Version 2.2 Official release notes -- 8/30/2004
  http://www.cerberusftp.com/

  - Added the SITE PSWD command to allow users to change their own passwords
  - Fixed a bug that could result in a file transfer error causing a 100% CPU utilization spike. 
  - Send and receive buffer settings now more directly affect file transfer speeds - Note: Has no
    impact when using "optimized file sending" mode
  - Anonymous passwords are now logged
  - Icon colors are now full color under all versions of Windows
  - New higher color Cerberus icon (thanks to Martin Nogué for donating the enhanced icon)
  - Fixed "group name too long" directory listing bug
  - Long directory listings now correctly display the year when the file is a year or older.


------------------------------------------------


Version 2.2 BETA 3 release notes -- 6/06/2004
  http://www.cerberusftp.com/

  - Added NT user and active directory authentication
  - User and group information is now displayed for files and directories
    during a long file listing (NT4, 2000, XP, 2003 only).
  - The "X" (Close) button now works in subwindows
  - Miscellaneous user interface fixes
  - Updated Help file


------------------------------------------------


Version 2.2 BETA 2 release notes -- 5/10/2004
  http://www.cerberusftp.com/

  - Corrected a Virtual Directory rename problem in the Usermanager
  - Added a safeguard check to prevent renaming of Virtual Directories with forward
    or backslashes


------------------------------------------------


Version 2.2 BETA 1 release notes -- 5/10/2004
  http://www.cerberusftp.com/


  - Changed the directory listing commands to accept and interpret common UNIX 'ls'
    flags within LIST and NLIST commands.
  - Added a simple directory mode in addition to the standard virtual directory mode
  - Greatly improved support for wildcards within LIST and NLIST commands
  - Greatly improved support for the common 'mget' ftp implementation thanks to better
    wildcards support
  - Pressing enter or esc after renaming an item in the User manager no longer closes the dialog box
  - Added support for Windows XP themes
  - Changed the look of many of the program icons
  - Added Web Services interface to many common FTP server tasks
  - Added a new simple virtual directory mode (see the help file for more details)
  - Added support for UNC paths as virtual directories
  - Users in the User manager are now sorted in alphabetical order
  

------------------------------------------------


Version 2.16 Official release notes -- 3/25/2004
  http://www.cerberusftp.com/


  - Fixed a bug that could result in an interface failing initialization in NT4
  - Added an option to disable the startup tip that appears when starting the server


------------------------------------------------


Version 2.15 Official release notes -- 2/06/2004
  http://www.cerberusftp.com/


  - Corrected a major bug in the 'Use different IP for PASV' mode option.


------------------------------------------------

Version 2.15 BETA release notes -- 1/25/2004
  http://www.cerberusftp.com/


  - Added a default interface to the interface configuration screen. The user-defined 
    settings from the default interface are now applied to new interfaces automatically.
  - Added an automatic IP-blocker. Administrators can now configure filters to automatically
    block IP addresses (temporarily or permanently) that fail authentication after
    a certain number of attempts.
  - Added a new network checklist screen to the Getting Started Wizard. The new wizard will
    point out possible problems in the network configuration that may cause problems with an
    FTP Server.
  - Added an auto-detect IP address feature. The server can now automatically detect and
    activate new interfaces, as well as clean up and deactivate interfaces that have been released.
  - Added a line limit option to the onscreen logger.
  - Corrected a bug with the 'Deny FXP Transfers' option.
  - Changed the look of the taskbar icon


------------------------------------------------

 
Version 2.11 release notes -- 12/21/2003
  http://www.cerberusftp.com/

  - Changed the permissions structure so that uploaded files cannot overwrite
    existing files unless the user has delete permission
  - The MDTM command can now be used to set the date/time on an uploaded file
  - Enhanced file send operations by allowing the OS to cache files
  - Added an option under the 'Advanced' tab of the server manager that instructs
    the server to use the 'TransmitFile' API call to send files. Not available on Windows 98.


------------------------------------------------
 
Version 2.11 BETA 2 release notes -- 11/11/2003
  http://www.cerberusftp.com/

  - Added automatic import of previous Cerberus settings(except interfaces)
  - Fixed a buffer overflow vulnerability
  - Added experimental support for the OPTS and LANG commands
  - Fixed a bug the caused a "550 Invalid Path" error message whenever a CWD
    to the root ("/") was issued
  - Resolved a bug that caused settings changes to be lost on restart when Cerberus
    was installed as a service
  - Corrected some cosmetic flaws in the GUI's server manager
  - Fixed a bug that turned off command logging when connection logging was turned off

------------------------------------------------
 
Version 2.11 BETA release notes -- 10/29/2003
  http://www.cerberusftp.com/
 
  - Adjusted the dialog button positioning so that the buttons wouldn't get clipped on XP
  - The login process has been changed so that incorrect usernames will now be
    prompted for passwords. This is a security enhancement.
  - Fixed a UI bug that could cause the Getting Started Wizard to keep showing up after
    a reboot
  - Added an option under the 'advanced' tab of the server manager to deny FXP transfers. 
  - Added an option under the 'advanced' tab of the server manager to deny PORT commands
    on the reserved ports (Ports below 1025). 
  - Passwords are not longer stored in the user file. Passwords are now SHA-1 encrypted, and
    then only the password message digest is stored.
  - Default programs are now invoked, instead of always Internet Explorer, for external links.
    Ex: mailto, Cerberus homepage web link, statistics file display.
  - The interface limit of 5 has been removed. Cerberus can now listen on an unlimited number
    of interfaces.
  - The list command has been changed to display the contents of directories passed as parameters
  - Updated help file
  - Numerous minor bug fixes and performance enhancements

------------------------------------------------

Version 2.1 Release notes -- 3/18/2003
  http://www.cerberusftp.com/
 
  - Added support for P@SW command to allow certain SMC Barricade routers
    to work with passive mode 
  - Added support for MDTM command
  - Added additional support for FEAT command
  - Improved support for running as a service
  - Added option to display file times in local or UTC format
  - Greatly reduced flicker on screen resizing
  - Added 'Getting Started' wizard to the GUI
  - Improved communication performance between the GUI and the server
  - Fixed bug which caused the PORT command to sometimes fail on NT4 
  - Several minor bug fixes

------------------------------------------------

Version 2.02 Release notes -- 1/07/2003
  http://www.cerberusftp.com/
 
  - Official release
  - Added PASV port range option to the 'Advanced' Server Configuration

------------------------------------------------

Version 2.02 BETA Release notes -- 12/22/2002
  http://www.cerberusftp.com/
  
  - Resolved a bug that allowed multiple versions of Cerberus to be
    started if Cerberus was running as a service, and a Terminal Services
    client started another version.
  - Fixed a bug that could, on rare occasions, cause the server to continuously
    attempt to terminate a connection that had already been terminated
  - Added an option to log server replys
  - Rewrote underlying socket communications to improve performance
  - Several minor bug fixes and performance improvements

------------------------------------------------

 Version 2.01 Release notes -- 10/17/2002
  http://www.cerberusftp.com/
  
  - Enhanced error detection and recovery
  - Corrected a bug which prevented networked drives from being displayed to clients
  - Changed the appearance of the Status Pane
  - Changed some of the toolbar icons to Hi-color icons
  - Added several commands to the 'right-click' menu of the User Manager
  - Added the option to 'Clone' (use as a base template) a user
  - Checked, and corrected where necessary, all string and buffer manipulations routines to
    make sure they were "buffer-overflow proof"
  - The uninstall program now removes Cerberus from the NT Service list

------------------------------------------------

  Version 2.0 Official Release notes -- 10/07/2002
  http://www.cerberusftp.com/
  
  - Corrected a bug that could result in an uploaded file being corrupt when overwriting
    and existing file of the same name.
  - Added the ability to control how many times an account can be logged into simultaneously

------------------------------------------------

  Version 2.0 BETA 4 Release notes -- 9/21/2002
  http://www.cerberusftp.com/

  - Corrected a bug which could prevent Cerberus from starting up on Windows 95 and 98
  - Fixed a bug in the registry access routines which could cause Cerberus to crash

------------------------------------------------

  Version 2.0 BETA 3 Release notes -- 9/20/2002
  http://www.cerberusftp.com/

  - Corrected the "The descriptor is not a socket" bug
  
------------------------------------------------

  Version 2.0 BETA 2 Release notes -- 9/16/2002
  http://www.cerberusftp.com/

  - New User Manager(comments?)
  - Several GUI changes and improvements

------------------------------------------------

  Version 2.0 BETA 1 Release notes -- 8/09/2002
  http://www.cerberusftp.com/
  
  - Completely new server core. No more MFC!
  - Can now be installed as a Native NT Service
  - Data Connections established through the PORT command now correctly bind to port 20 (RfC959).
    Should help with firewalls
  - Corrected a bug that occasionally caused uploaded files to be closed before the last few 
    kilobytes were written. 
  - The User Manager has been revamped again. Automatically saves changes, instead of constantly
    asking for permission
  - Ability to control whether or not to display hidden files and directories
  - New toolbar icons
  - Added a context menu to the connections page
  - Ability to manually add interfaces
  - Support for files greater than 4GB
  - Too many security and bug fixes to list

------------------------------------------------

  Version 1.71 Release notes -- 2/07/2002
  
  - Only one copy of Cerberus can start at a time
  - The User Manager has been made more user friendly
  - Settings and user lists now save automatically when windows is shutting down
  - Rewrote the directory parsing routines for greater reliability

------------------------------------------------

  Version 1.7 Release notes -- 12/16/2001

  - Fixed the "Invalid Path" error that showed up when a file or directory with more 
    than one period was used in a command
  - Directories added to a user's virtual root can now have different permissions
  - The user manager has been redesigned to be more user friendly
  - Fixed a bug that caused processor utilization to sometimes spike when a file was
    downloaded.
  - Command progress indication. The user page will tell whether a command is in 
    progress or complete. For file downloads, the percentage left to download will be
    displayed.
  - Fixed a bug that could cause the server to crash if a message greater than 4KB
    was specified in either the welcome, goodbye, or max connection edit boxes.
  - Fixed a bug that could cause the server to crash if the server wasn't restarted
    after a message was changed.
  - Many other bug fixes and improvements
   
------------------------------------------------

  Version 1.6 Beta Release notes -- 8/25/2001 

  - Fixed a MAJOR security bug that allowed unrestricted access to the
    server machine by using periods in the change directory path
  - Modified the directory retrieval commands to more closely model Unix behavior
    Should fix the problems encountered using the mget * command
  - Complete rewrite of the underlying directory parsing functions
  - Lots of other minor fixes and improvements

------------------------------------------------

  Version 1.5 Release notes -- 5/21/2001

  - Added a new virtual root directory file structure
  - Added support for the APPEnd command
  - The server now remembers whether an interface is disabled or enabled
  - Enhanced the fault tolerance for clients that send incorrect or 
    unsupported commands by ensuring a reply code is always sent
  - Added this help file
  - Corrected a bug in the IP Manager that caused all IP addresses placed
    inside to be blocked regardless of whether the deny or allow button was selected
  - CWD command now fails if anything other than a valid directory is passed
  - Activated the "Allow Login" feature for particular interfaces
  - Server now handles X-versions(experimental) of commands
  - Maximum connection settings are now enforced
  - Streamlined a lot of the underlying code

------------------------------------------------

  Version 1.22 Release notes -- 5/08/2001

  - Fixed a security problem that always uses c:\ as the root directory for anonymous logins.<br>	
  - Replaced the imbedded directory control in User manager with a more stable one<br>	
  - Rewrote the command parsing routines to provide greater fault tolerance for incorrectly 
    formatted, or garbage strings on the control connection

------------------------------------------------

  Version 1.2 Release notes -- 5/03/2001 

  - Changed OS (UNIX) returned from SITE command. Should improve FTP auto-detect.
  - Fixed a security hole that allowed people to execute certain commands without being logged in
  - Removed the hard-coded paths; International versions of Windows should work now.
  - Some stability improvements

------------------------------------------------

  Version 1.1 Release notes -- 4/25/2001 

  - Fixed the CWD command to fail when the remote directory requested doesn't exist
  - Added support for the CDUP command
  - Added additional log messages for file transfers
  - Major code rewrites to improve overall performance
  - New statistic generator
  - Added additional error checking during remote path resolution
  - Some GUI changes/improvements
  - Fixed a major bug that caused PASV file uploads to fail
  - Several other minor bug fixes
  - Modified the directory structure sent with the LIST command to mirror UNIX exactly
  - Increased compatibility with popular FTP clients
  - Partial support for the ABORt command

------------------------------------------------

  Version 1.05 Release notes -- 4/16/2001 

  - Added support for the SIZE and REST commands. The server can now restart
    failed file transfers from the point of failure
  - Fixed a MAJOR security issue that caused upload/download permissions to not
    be checked for users
  - Added the creation of the 'log' directory so that the AutoLog option wouldn't error
    when attempting to open the log file
  - Corrected the "incorrect user file version" bug that appears when you restart 
    the server (note: delete the old user and block files)
  - Corrected a bug in the STOU command that caused the wrong procedure to be called.
  - Optimized the file transfer code and added improved error detection
  - Thanks to everyone who has submitted bug reports

------------------------------------------------

  Version 1.03 Release notes -- 4/14/2001 

  - Corrected a bug introduced in the last version that resulted in the wrong OS being 
    detected (currently harmless, but annoying)

------------------------------------------------

  Version 1.02 Release notes -- 4/13/2001 

  - Added an IP Manager to control connection attempts
  - Added an option to automatically record a log file while the server is running
  - More event tracking added to the log
  - Enhanced error detection and recovery

------------------------------------------------

  Version 1.01 Release notes -- 4/5/2001 

  - Added menu options to the taskbar icon
  - You can now hide or show the Cerberus manager window from the taskbar
  - Added an option to hide the server manager window at startup
  - Added my email address to the about dialog for tech support
  - Activated the ability to save a copy of the log screen to file

------------------------------------------------

  Version 1.0 Release notes -- 3/14/2001 

  - Initial Release
